%define anolis_release 3

%global glib2_version 2.72
%global colord_version 1.4.6
%global geocode_glib_version 3.26.3
%global gnome_desktop_version 42.0
%global gsettings_desktop_schemas_version 42.0
%global gtk3_version 3.24.27
%global geoclue_version 2.6.0

%global systemd_units org.gnome.SettingsDaemon.A11ySettings.service org.gnome.SettingsDaemon.Color.service org.gnome.SettingsDaemon.Datetime.service org.gnome.SettingsDaemon.Housekeeping.service org.gnome.SettingsDaemon.Keyboard.service org.gnome.SettingsDaemon.MediaKeys.service org.gnome.SettingsDaemon.Power.service org.gnome.SettingsDaemon.PrintNotifications.service org.gnome.SettingsDaemon.Rfkill.service org.gnome.SettingsDaemon.ScreensaverProxy.service org.gnome.SettingsDaemon.Sharing.service org.gnome.SettingsDaemon.Smartcard.service org.gnome.SettingsDaemon.Sound.service org.gnome.SettingsDaemon.UsbProtection.service org.gnome.SettingsDaemon.Wwan.service org.gnome.SettingsDaemon.XSettings.service

%global major_version %%(echo %{version} | cut -f 1 -d '~' | cut -f 1 -d '.')

Name:           gnome-settings-daemon
Version:        44.1
Release:        %{anolis_release}%{?dist}
Summary:        The daemon sharing settings from GNOME to GTK+/KDE applications

License:        GPLv2+
URL:            https://gitlab.gnome.org/GNOME/gnome-settings-daemon
Source0:        https://download.gnome.org/sources/%{name}/%{major_version}/%{name}-%{version}.tar.xz

Patch1000:      1000-disable-sleep-for-idle.patch

BuildRequires:  meson >= 0.49.0 gcc cups-devel gettext pkgconfig(glib-2.0) >= %{glib2_version}
BuildRequires:  perl-interpreter pkgconfig(gcr-4) pkgconfig(libwacom) >= 0.7 pkgconfig(xorg-wacom)
BuildRequires:  pkgconfig(alsa) pkgconfig(fontconfig) pkgconfig(colord) >= %{colord_version}
BuildRequires:  pkgconfig(geoclue-2.0) >= %{geoclue_version} pkgconfig(geocode-glib-2.0) >= %{geocode_glib_version}
BuildRequires:  pkgconfig(gnome-desktop-3.0) >= %{gnome_desktop_version}
BuildRequires:  pkgconfig(gsettings-desktop-schemas) >= %{gsettings_desktop_schemas_version}
BuildRequires:  pkgconfig(gtk+-3.0) >= %{gtk3_version} pkgconfig(gudev-1.0) pkgconfig(gweather4)
BuildRequires:  pkgconfig(lcms2) >= 2.2 pkgconfig(libcanberra-gtk3) pkgconfig(libgeoclue-2.0) 
BuildRequires:  pkgconfig(libnm) pkgconfig(libnotify) pkgconfig(libpulse) pkgconfig(libpulse-mainloop-glib)
BuildRequires:  pkgconfig(librsvg-2.0) pkgconfig(mm-glib) pkgconfig(nss) pkgconfig(polkit-gobject-1)
BuildRequires:  pkgconfig(upower-glib) pkgconfig(x11) pkgconfig(xi) pkgconfig(wayland-client)

Requires: colord >= %{colord_version} iio-sensor-proxy glib2 >= %{glib2_version} libgweather
Requires: geoclue2 >= %{geoclue_version} geocode-glib >= %{geocode_glib_version} gtk3 >= %{gtk3_version} 
Requires: gsettings-desktop-schemas >= %{gsettings_desktop_schemas_version} gnome-desktop3 >= %{gnome_desktop_version}

%description
The GNOME Settings Daemon is responsible for setting various parameters of a
GNOME Session and the applications that run under it.

This package is known to build and work properly using an LFS-9.0 platform.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{EVR}

%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

%package        doc
Summary:        Doc files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -p1 -n %{name}-%{version}

%build
%meson
%meson_build

%install
%meson_install

%find_lang %{name} --with-gnome

%post
%systemd_user_post %{systemd_units}
 
%preun
%systemd_user_preun %{systemd_units}

%files -f %{name}.lang
%license COPYING

# list daemons explicitly, so we notice if one goes missing
# some of these don't have a separate gschema
%{_libexecdir}/gsd-datetime
%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.Datetime.desktop

%{_libexecdir}/gsd-housekeeping
%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.Housekeeping.desktop
%{_datadir}/glib-2.0/schemas/org.gnome.settings-daemon.plugins.housekeeping.gschema.xml

%{_libexecdir}/gsd-keyboard
%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.Keyboard.desktop

%{_libexecdir}/gsd-media-keys
%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.MediaKeys.desktop
%{_datadir}/glib-2.0/schemas/org.gnome.settings-daemon.plugins.media-keys.gschema.xml

%{_libexecdir}/gsd-backlight-helper
%{_datadir}/polkit-1/actions/org.gnome.settings-daemon.plugins.power.policy
%{_libexecdir}/gsd-power
%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.Power.desktop
%{_datadir}/glib-2.0/schemas/org.gnome.settings-daemon.plugins.power.gschema.xml

%{_libexecdir}/gsd-print-notifications
%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.PrintNotifications.desktop
%{_libexecdir}/gsd-printer

%{_libexecdir}/gsd-rfkill
%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.Rfkill.desktop

%{_libexecdir}/gsd-screensaver-proxy
%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.ScreensaverProxy.desktop

%{_libexecdir}/gsd-smartcard
%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.Smartcard.desktop

%{_libexecdir}/gsd-sound
%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.Sound.desktop

%{_libexecdir}/gsd-usb-protection
%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.UsbProtection.desktop

%{_datadir}/glib-2.0/schemas/org.gnome.settings-daemon.peripherals.gschema.xml
%{_datadir}/glib-2.0/schemas/org.gnome.settings-daemon.peripherals.wacom.gschema.xml
%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.Wacom.desktop

%{_libexecdir}/gsd-wacom
%{_libexecdir}/gsd-wacom-oled-helper
%{_datadir}/polkit-1/actions/org.gnome.settings-daemon.plugins.wacom.policy

%{_libexecdir}/gsd-xsettings
%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.XSettings.desktop
%{_datadir}/glib-2.0/schemas/org.gnome.settings-daemon.plugins.xsettings.gschema.xml

%{_libexecdir}/gsd-a11y-settings
%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.A11ySettings.desktop

%{_libexecdir}/gsd-color
%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.Color.desktop
%{_datadir}/glib-2.0/schemas/org.gnome.settings-daemon.plugins.color.gschema.xml

%{_libexecdir}/gsd-sharing
%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.Sharing.desktop
%{_datadir}/glib-2.0/schemas/org.gnome.settings-daemon.plugins.sharing.gschema.xml

%{_sysconfdir}/xdg/autostart/org.gnome.SettingsDaemon.Wwan.desktop
%{_libexecdir}/gsd-wwan
%{_datadir}/glib-2.0/schemas/org.gnome.settings-daemon.plugins.wwan.gschema.xml

%dir %{_libdir}/gnome-settings-daemon-%{major_version}
%{_libdir}/gnome-settings-daemon-%{major_version}/libgsd.so

%{_sysconfdir}/xdg/Xwayland-session.d/00-xrdb
%{_userunitdir}/*
/usr/lib/udev/rules.d/*.rules
%{_datadir}/gnome-settings-daemon/
%{_datadir}/GConf/gsettings/gnome-settings-daemon.convert

%{_datadir}/glib-2.0/schemas/org.gnome.settings-daemon.enums.xml
%{_datadir}/glib-2.0/schemas/org.gnome.settings-daemon.plugins.gschema.xml

%files devel
%{_includedir}/gnome-settings-daemon-%{major_version}
%{_libdir}/pkgconfig/gnome-settings-daemon.pc

%files doc
%doc README AUTHORS NEWS

%changelog
* Tue Jun 18 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 44.1-3
- Disable sleep for idle

* Sun Aug 6 2023 Funda Wang <fundawang@yeah.net> - 44.1-2
- Fix systemd units name in scriptlets

* Wed Apr 19 2023 Funda Wang <fundawang@yeah.net> - 44.1-1
- New version 44.1

* Thu Apr 13 2023 yuanhui <yuanhui@linux.alibaba.com> - 44.0-2
- Optimize the spec file

* Wed Apr 05 2023 Funda Wang <fundawang@yeah.net> - 44.0-1
- New version 44.0

* Wed Apr 05 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 44.rc-3
- Build against geocode-glib2 for libsoup3 support

* Mon Mar 20 2023 yuanhui <yuanhui@linux.alibaba.com> - 44.rc-2
- Rebuild with gnome-desktop3-44~beta

* Sat Mar 18 2023 happy_orange <songnannan@linux.alibaba.com> - 44.rc-1
- update to 44~rc

* Tue Feb 21 2023 Funda Wang <fundawang@yeah.net> - 42.2-2
- Fix requires

* Mon Dec 12 2022 Funda Wang <fundawang@yeah.net> - 42.2-1
- New version 42.2

* Wed Apr 13 2022 gcdota930915 <taifu.gc@alibaba-inc.com> - 42.1-1
- Init from upstream version 42.1
